//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "pe_unit.h"
#include <winnt.h>
#include <string.h>


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
AnsiString pDir;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

void __fastcall TForm1::O1Click(TObject *Sender)
{
    Application->MessageBox(
    "   DLL .\n: Kr0m\nCopyRight (c) 2004",
    " ...",MB_OK);
}
//---------------------------------------------------------------------------
void TForm1::parse_error()
{
   char *msg;
      FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
                    NULL,
                    GetLastError(),
                    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
                    (LPTSTR) &msg,
                    0,
                    NULL);
   Log->Lines->Add(msg);
   delete [] msg;
}


//---------------------------------------------------------------------------
void __fastcall TForm1::N3Click(TObject *Sender)
{
    Close();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::N2Click(TObject *Sender)
{
    if (!openF->Execute())
        return;

    Log->Lines->Add(" : " + openF->FileName);
    Application->ProcessMessages();

    IMAGE_DOS_HEADER *mz_head;
    IMAGE_FILE_HEADER *pe_head;
    IMAGE_OPTIONAL_HEADER *pe_opt_head;
    IMAGE_SECTION_HEADER *sect;

    char pe[] = "PE\0\0";

    HANDLE f = NULL;
    f = CreateFile(openF->FileName.c_str(), GENERIC_READ | GENERIC_WRITE,
                        FILE_SHARE_WRITE, NULL,
                        OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if (f == INVALID_HANDLE_VALUE)
        {
         Log->Lines->Add("   : ");
         parse_error();
         return;
        }

    HANDLE fMap = CreateFileMapping( f, NULL,
                                        PAGE_READWRITE,
                                        0, 0, NULL);
    CloseHandle(f);
    if (fMap == NULL)
      {
         Log->Lines->Add("   CreateFileMapping(): ");
         parse_error();
         return;
      }

    int size = sizeof( IMAGE_DOS_HEADER );

    LPVOID fBeg = MapViewOfFile( fMap, FILE_MAP_WRITE, 0, 0, size);
    if (fBeg == NULL)
      {
         Log->Lines->Add("   MapViewOfFile(): ");
         parse_error();
         return;
      }

    //  -.
    mz_head = (IMAGE_DOS_HEADER *)fBeg;
    DWORD peOffset = mz_head->e_lfanew;
    UnmapViewOfFile(fBeg);

    //       -
    size = peOffset + sizeof( DWORD ) +  sizeof( IMAGE_FILE_HEADER )
                + sizeof( IMAGE_OPTIONAL_HEADER );

    fBeg = MapViewOfFile( fMap, FILE_MAP_READ, 0, 0, size);
    if (fBeg == NULL)
        {
         Log->Lines->Add("   MapViewOfFile(): ");
         parse_error();
         CloseHandle(fMap);return;
        }

    mz_head = (IMAGE_DOS_HEADER *)fBeg;
    (DWORD)pe_head = (DWORD)fBeg + peOffset;

    //, PE   PE 
    if ( strcmp(pe,(const char *)pe_head) != 0)
        {
        Log->Lines->Add("    Portable Executable - .");
        UnmapViewOfFile(fBeg);CloseHandle(fMap);
        return;
        }
    UnmapViewOfFile(fBeg);

    //      
    fBeg = MapViewOfFile( fMap, FILE_MAP_WRITE, 0, 0, 0);
    if (fBeg == NULL)
      {
      Log->Lines->Add("   MapViewOfFile(): ");
      parse_error();
      CloseHandle(fMap); return;
      }

    mz_head = (IMAGE_DOS_HEADER *)fBeg;
    (DWORD)pe_head = (DWORD)fBeg + peOffset + sizeof(DWORD);
    (DWORD)pe_opt_head = (DWORD)pe_head + sizeof(IMAGE_FILE_HEADER);

    //      ...
    DWORD ImportRVA = pe_opt_head->DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress;
    int sect_num = -1;

    //    ...
    (DWORD)sect = (DWORD)pe_opt_head + sizeof(IMAGE_OPTIONAL_HEADER);
    int i;
    for ( i=0; i<pe_head->NumberOfSections; i++)
        {
        if ( ImportRVA < sect->VirtualAddress )
                {
                sect--;
                sect_num=i-1;
                break;
                }
        sect++;
        }

    if (sect_num == -1)
        {
        Log->Lines->Add("     !");
        UnmapViewOfFile(fBeg);CloseHandle(fMap);
        return;
        }

    //    DWORD ImportSectAddr = (DWORD)sect;
    sect++;

    // Next after import table section RVA
    // DWORD NextAfterImportRVA = sect->VirtualAddress;
    DWORD AfterImportSecBeg = (DWORD)fBeg + sect->PointerToRawData;
    sect--;

    LPVOID ImportSecBeg;//    
                        //c   .
    (DWORD)ImportSecBeg = (DWORD)fBeg + sect->PointerToRawData;

    //      
    //   ().
    LPVOID ImportTable;
    (DWORD)ImportTable =  ImportRVA - sect->VirtualAddress;
    (DWORD)ImportTable = (DWORD)ImportSecBeg
                           + (DWORD)ImportTable;

    IMAGE_IMPORT_DESCRIPTOR *DLLInfo = (IMAGE_IMPORT_DESCRIPTOR *)ImportTable;
    LPVOID DLLName;
    DWORD DLLCounter = 0;

    while (DLLInfo->Name != NULL)
      {
      DLLCounter++;
      (DWORD)DLLName = (DWORD)DLLInfo->Name - sect->VirtualAddress;
      (DWORD)DLLName = (DWORD)ImportSecBeg + (DWORD)DLLName;
      Log->Lines->Add(IntToStr(DLLCounter)+"->"+(LPSTR)DLLName);
      Application->ProcessMessages();
      DLLInfo++;
      }
    Log->Lines->Add("  "+IntToStr(DLLCounter) + " .");

    //
    //Counting needed size in bytes for new import table
    DWORD NewImportTableSize = sizeof(IMAGE_IMPORT_DESCRIPTOR)*(DLLCounter+2);

    //      
    LPVOID pos;
    (DWORD)pos = AfterImportSecBeg-1;

    DWORD maxFree = 0;
    DWORD prevPtr;
    LPVOID FreePtr = NULL;

    //    ...
    while ( pos >= ImportSecBeg )
      {
      if ( *(BYTE *)pos == 0x00  )
         {
         prevPtr = (DWORD)pos;
         while (*(BYTE *)pos == 0x00)
            (DWORD)pos -= 1;
         if ( ((DWORD)prevPtr - (DWORD)pos) > maxFree )
            {
            maxFree = ((DWORD)prevPtr - (DWORD)pos);
            (DWORD)FreePtr = (DWORD)pos + 1;
            }
         }
      (DWORD)pos -= 1;
      }

   //     , ..
   //      DWORD - 
   (LPDWORD)FreePtr +=1;
   maxFree -=4;

   //   
   if ( maxFree < NewImportTableSize )
      {
      Log->Lines->Add("      \
           .");
      UnmapViewOfFile(fBeg);
      CloseHandle(fMap);
      return;
      }
   else
      Log->Lines->Add("      .");
   Application->ProcessMessages();

   Log->Lines->Add("\na   DLL...");
   Application->ProcessMessages();

   //1.       
   memcpy(FreePtr, ImportTable, sizeof(IMAGE_IMPORT_DESCRIPTOR)*DLLCounter);

   //2.1      DLL    
   //(  )
   memcpy(ImportTable, OUR_DLL_NAME, strlen(OUR_DLL_NAME));

   LPDWORD zeroPtr;
   (DWORD)zeroPtr = (DWORD)ImportTable + strlen(OUR_DLL_NAME);

   //2.2   IMAGE_IMPORT_BY_NAME    .
   //(    )
   IMAGE_IMPORT_BY_NAME myName;
   myName.Hint = 0x00;
   myName.Name[0] = 0x00;

   WORD Hint = 0;
   char myFuncName[] = OUR_FUNC_NAME;

   hackRec patch;
   patch.ZeroDword = NULL;
   patch.IAT = ImportRVA + strlen(OUR_DLL_NAME) + sizeof(hackRec);
   patch.IATEnd = NULL;

   DWORD IIBN_Table;

   memcpy(zeroPtr, &patch, sizeof(patch));
   (DWORD)zeroPtr += sizeof(patch);
   memcpy(zeroPtr, &Hint, sizeof(WORD));
   (DWORD)zeroPtr += sizeof(WORD);
   memcpy(zeroPtr, myFuncName, strlen(myFuncName)+1 );
   (DWORD)zeroPtr += strlen(myFuncName)+1;
   memcpy(zeroPtr, &myName, sizeof(IMAGE_IMPORT_BY_NAME) );

   //2.3.   IMAGE_IMPORT_BY_NAME    DLL
   IMAGE_IMPORT_DESCRIPTOR myDLL;

   //     IMAGE_IMPORT_BY_NAME: 
   //      +     
   // DLL +  DWORD
   IIBN_Table = ImportRVA + strlen( OUR_DLL_NAME ) + sizeof(DWORD);

   //   Characteristics
   myDLL.Characteristics = IIBN_Table;
   myDLL.TimeDateStamp = NULL;
   myDLL.ForwarderChain = NULL;                                   

   //       DLL
   myDLL.Name = ImportRVA;

   //   FirstThunk
   myDLL.FirstThunk = IIBN_Table;

   //        DLL
   LPVOID OldFreePtr = FreePtr;
   (DWORD)FreePtr +=sizeof(IMAGE_IMPORT_DESCRIPTOR)*DLLCounter;
   memcpy(FreePtr, &myDLL, sizeof(IMAGE_IMPORT_DESCRIPTOR));

   // ""       
   myDLL.Characteristics = NULL;
   myDLL.TimeDateStamp = NULL;
   myDLL.ForwarderChain = NULL;
   myDLL.Name = NULL;
   myDLL.FirstThunk = NULL;
   
   //       .
   (DWORD)FreePtr +=sizeof(IMAGE_IMPORT_DESCRIPTOR)*DLLCounter;
   memcpy(FreePtr, &myDLL, sizeof(IMAGE_IMPORT_DESCRIPTOR));

   //3.      .
   //  RVA  
   DWORD NewImportTableRVA = (DWORD)OldFreePtr - (DWORD)ImportSecBeg +
                              sect->VirtualAddress;

   //    DataDirectory
   pe_opt_head->DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress =
                              NewImportTableRVA;
   pe_opt_head->DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].Size =
            (DLLCounter + 1) * sizeof(IMAGE_IMPORT_DESCRIPTOR);

   //Additional changes 28.11.2002
   pe_opt_head->DataDirectory[IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT].VirtualAddress = 0;
   pe_opt_head->DataDirectory[IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT].Size = 0;

   pe_opt_head->DataDirectory[IMAGE_DIRECTORY_ENTRY_IAT].VirtualAddress = 0;
   pe_opt_head->DataDirectory[IMAGE_DIRECTORY_ENTRY_IAT].Size = 0;


   //   pe_opt_head->DataDirectory[].v
   Log->Lines->Add("   \'azx\'.      azx    .");

   UnmapViewOfFile(fBeg);
   CloseHandle(fMap);
}
